//---------------------------------------------------------------------------
// This routine manages the color palettes used by the two waterfalls
//---------------------------------------------------------------------------
#include <vcl.h>
#include "pch.h"
#pragma  hdrstop

#include "ComputePalette.h"

MYPAL logpal ={0x300, 256};

//---------------------------------------------------------------------------
HPALETTE ComputePalette()
{
  static short (*palette)[256][3];
  static bool firstime = true;

  if(firstime)
  {
    firstime = false;
    for(int k = 0; k < 256; k++)
    {
      LinradPaletteData[k][2] = LinradColors[k] >> 16;
      LinradPaletteData[k][1] = (LinradColors[k] >> 8) & 0x000000ff;
      LinradPaletteData[k][0] = (LinradColors[k])      & 0x000000ff;
    }
  }

  switch(MainForm->activePalette)
  {
     case darker   : palette = &LinPaletteData;     break;
     case Spectran : palette = &LogPaletteData;     break;
     case lighter  : palette = &NewPaletteData;     break;
     case Horne    : palette = &HrnPaletteData;     break;
     case SpecExt  : palette = &FullDynPaletteData; break;
     case Winrad   : palette = &FullDyn2PaletteData;break;
     case Linrad   : palette = &LinradPaletteData;  break;
  }

  logpal.palPalEntry[0].peRed   = 0;
  logpal.palPalEntry[0].peGreen = 0;
  logpal.palPalEntry[0].peBlue  = 0;
  logpal.palPalEntry[0].peFlags = NULL;

  for(int k=1; k<256; k++)
  {  logpal.palPalEntry[k].peRed   = (*palette)[k][0];
     logpal.palPalEntry[k].peGreen = (*palette)[k][1];
     logpal.palPalEntry[k].peBlue  = (*palette)[k][2];
     logpal.palPalEntry[k].peFlags = NULL;
  }

  return CreatePalette((const tagLOGPALETTE *)&logpal);
}

#pragma package(smart_init)
