//---------------------------------------------------------------------------
#ifndef HFButtH
#define HFButtH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <math.h>

typedef  enum {B6, B10, B12, B15, B17, B20, B30, B40, B80, B160,
			   LPT1, LPT2, USB, PRE, ATT, AHF, AVHF, RESPRE,
			   INIDDS, UP, DOWN} type;
//---------------------------------------------------------------------------
class PACKAGE THFButt : public TGraphicControl
{
private:
   bool  Fdown;     // ON/OFF status of the button
   bool  Fradio;    // radio. behaves like a radio button
   type  Ftype;
   Graphics::TBitmap *ONBitmap;
   Graphics::TBitmap *OFFBitmap;

   void __fastcall SetRadio(bool radio);
   void __fastcall SetBand(type type);
   void __fastcall SetDown(bool status);
   void __fastcall ResetBitmap(void);

protected:
   void __fastcall Paint();

   DYNAMIC void __fastcall MouseDown(TMouseButton Button,
           TShiftState Shift, int X, int Y);
   DYNAMIC void __fastcall MouseUp(TMouseButton Button,
           TShiftState Shift, int X, int Y);
   DYNAMIC void __fastcall MouseMove(TShiftState Shift, int X, int Y);
   TMouseEvent fOnMouseDown;
   TMouseEvent fOnMouseUp;
   TMouseMoveEvent fOnMouseMove;

public:
   DYNAMIC void __fastcall Click();
   __fastcall THFButt(TComponent* Owner);
   __fastcall ~THFButt();

__published:
   __property bool RadioButton={read=Fradio, write=SetRadio, default=true};
   __property bool Down={read=Fdown, write=SetDown, default=false};
   __property type Type={read=Ftype, write=SetBand, default=B40};
   __property Enabled={default=true};
   __property OnClick;
   __property OnMouseDown={read=fOnMouseDown, write=fOnMouseDown};
   __property OnMouseUp={read=fOnMouseUp,     write=fOnMouseUp};
   __property OnMouseMove={read=fOnMouseMove, write=fOnMouseMove};

};
//---------------------------------------------------------------------------
#endif
