// CodeGear C++Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Nakedslider.pas' rev: 11.00

#ifndef NakedsliderHPP
#define NakedsliderHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Nakedslider
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TBarStyle { bsLowered, bsRaised };
#pragma option pop

#pragma option push -b-
enum TOrientation { orVertical, orHorizontal };
#pragma option pop

#pragma option push -b-
enum TThumbStyle { tsBar1, tsBar2, tsBar3, tsBar4, tsCircle1, tsSquare1, tsDiamond1, tsDiamond2, tsDiamond3, tsDiamond4, tsStdDown, tsStdUp, tsStdVBar, tsStdUpDown, tsStdLeft, tsStdRight, tsStdHBar, stStdLeftRight };
#pragma option pop

class DELPHICLASS TNakedSlider;
class PASCALIMPLEMENTATION TNakedSlider : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	Graphics::TColor FFocusColor;
	bool FHandCursor;
	Classes::TStringList* FLabels;
	int FMax;
	int FMin;
	int FPosition;
	TOrientation FOrientation;
	TBarStyle FStyle;
	Byte FThickness;
	TThumbStyle FThumbStyle;
	bool FFlashColor;
	int FFrequency;
	int FStepLine;
	int FStepPage;
	Classes::TNotifyEvent FOnChange;
	Graphics::TBitmap* ThumbBmp;
	Graphics::TBitmap* MaskBmp;
	Graphics::TBitmap* BkgdBmp;
	Graphics::TBitmap* FullBackBmp;
	bool BackSaved;
	int DragVal;
	int HalfTW;
	int HalfTH;
	#pragma pack(push,1)
	Types::TRect ThumbRect;
	#pragma pack(pop)
	#pragma pack(push,1)
	Types::TRect CanvRect;
	#pragma pack(pop)
	HICON HandPointer;
	void __fastcall SetLabels(Classes::TStringList* Value);
	void __fastcall SetMax(int Value);
	void __fastcall SetMin(int Value);
	void __fastcall SetOrientation(TOrientation Value);
	void __fastcall SetPosition(int Value);
	void __fastcall SetStyle(TBarStyle Value);
	void __fastcall SetThickness(Byte Value);
	void __fastcall SetThumbStyle(TThumbStyle Value);
	void __fastcall SetFlashColor(bool Value);
	void __fastcall SetFrequency(int Value);
	void __fastcall SetStepLine(int Value);
	void __fastcall SetStepPage(int Value);
	MESSAGE void __fastcall CMEnter(Messages::TWMNoParams &Message);
	MESSAGE void __fastcall CMExit(Messages::TWMNoParams &Message);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Message);
	MESSAGE void __fastcall WMSetCursor(Messages::TWMSetCursor &Message);
	MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	
protected:
	bool Dragging;
	virtual void __fastcall Paint(void);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	int __fastcall NewPosition(int WhereX, int WhereY);
	bool __fastcall IsVert(void);
	void __fastcall RemoveThumbBar(void);
	void __fastcall DrawThumbBar(void);
	void __fastcall DrawTrench(void);
	void __fastcall SaveBackground(void);
	void __fastcall SaveFullBackground(void);
	void __fastcall WhereIsBar(void);
	void __fastcall SetTLColor(void);
	void __fastcall SetBRColor(void);
	
public:
	__fastcall virtual TNakedSlider(Classes::TComponent* AOwner);
	__fastcall virtual ~TNakedSlider(void);
	AnsiString __fastcall CurrentLabel();
	void __fastcall MoveDown(int iDist);
	void __fastcall MoveUp(int iDist);
	
__published:
	__property Enabled  = {default=1};
	__property Graphics::TColor FocusColor = {read=FFocusColor, write=FFocusColor, default=12632256};
	__property bool HandCursor = {read=FHandCursor, write=FHandCursor, default=1};
	__property Classes::TStringList* Labels = {read=FLabels, write=SetLabels};
	__property int Max = {read=FMax, write=SetMax, default=10};
	__property int Min = {read=FMin, write=SetMin, default=1};
	__property TOrientation Orientation = {read=FOrientation, write=SetOrientation, default=0};
	__property ParentShowHint  = {default=1};
	__property int Position = {read=FPosition, write=SetPosition, default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property TBarStyle Style = {read=FStyle, write=SetStyle, default=0};
	__property Byte Thickness = {read=FThickness, write=SetThickness, default=1};
	__property TThumbStyle ThumbStyle = {read=FThumbStyle, write=SetThumbStyle, default=2};
	__property bool FlashColor = {read=FFlashColor, write=SetFlashColor, default=0};
	__property int Frequency = {read=FFrequency, write=SetFrequency, default=1};
	__property int StepLine = {read=FStepLine, write=SetStepLine, default=1};
	__property int StepPage = {read=FStepPage, write=SetStepPage, nodefault};
	__property Visible  = {default=1};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Nakedslider */
using namespace Nakedslider;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Nakedslider
