//---------------------------------------------------------------------------

#ifndef RingH
#define RingH

#include "nsp.h"

//---------------------------------------------------------------------------
class TFRing
{
private:
   float *ring;
   int Top, Que, headroom, size;

public:
   __fastcall TFRing(int len);
   __fastcall ~TFRing(void);

   bool __fastcall get(float* el, int len);
   bool __fastcall put(float* el, int len);
   int  __fastcall getlen(void);
};
//---------------------------------------------------------------------------
class TDRing
{
private:
   double *ring;
   int Top, Que, headroom, size;

public:
   __fastcall TDRing(int len);
   __fastcall ~TDRing(void);

   bool __fastcall get(double* el, int len);
   bool __fastcall put(double* el, int len);
   int  __fastcall getlen(void);
};
//---------------------------------------------------------------------------
class TIRing
{
private:
   int *ring;
   int Top, Que, headroom, size;

public:
   __fastcall TIRing(int len);
   __fastcall ~TIRing(void);

   bool __fastcall get(int* el, int len);
   bool __fastcall put(int* el, int len);
   int  __fastcall getlen(void);
   void __fastcall clear(void);
};
//---------------------------------------------------------------------------
class TVRing
{
private:
   char *ring;
   int  Top, Que, headroom, size, elsize;

public:
   __fastcall TVRing(int len, int elementsize);
   __fastcall ~TVRing(void);

   bool __fastcall get(char* el, int len);
   bool __fastcall put(char* el, int len);
   int  __fastcall getlen(void);
};
//---------------------------------------------------------------------------
class TCRing
{
private:
   SCplx *ring;
   int Top, Que, headroom, size;

public:
   __fastcall TCRing(int len);
   __fastcall ~TCRing(void);

   bool __fastcall get(SCplx* el, int len);
   bool __fastcall put(SCplx* el, int len);
   int  __fastcall getlen(void);
};
//---------------------------------------------------------------------------
class TIQFifo
{
private:
   short *fifo, *Top, *Que;
   int   numel, len;

public:
   __fastcall TIQFifo(int num, int len);
   __fastcall ~TIQFifo(void);

   bool __fastcall getp(short* &el);
   bool __fastcall put(short* el);
   int  __fastcall getnum(void);
};
//---------------------------------------------------------------------------
class TIQFifo24
{
private:
   char  *fifo, *Top, *Que;
   int   numel, len;

public:
   __fastcall TIQFifo24(int num, int len);
   __fastcall ~TIQFifo24(void);

   bool __fastcall getp(void* &el);
   bool __fastcall put(void* el);
   int  __fastcall getnum(void);
};
//---------------------------------------------------------------------------
class TIQFifo32
{
private:
   char  *fifo, *Top, *Que;
   int   numel, len;

public:
   __fastcall TIQFifo32(int num, int len);
   __fastcall ~TIQFifo32(void);

   bool __fastcall getp(void* &el);
   bool __fastcall put(void* el);
   int  __fastcall getnum(void);
};
//---------------------------------------------------------------------------

#endif
