//---------------------------------------------------------------------------
// here the settings of the program are saved for the next execution
//---------------------------------------------------------------------------

#include <vcl.h>
#include "pch.h"
#pragma  hdrstop

#include "SaveSettings.h"

void __fastcall TMainForm::SaveSettings(char *name)
{

   WinradStatus param;
   String  KeyName("Software\\digiRadio");
   Byte    KeyValue[sizeof(param)];
   char    cfgname[128] = {"Config_"};

   TRegistry& SettingsReg = *(new TRegistry);
   SettingsReg.RootKey  = HKEY_CURRENT_USER;

   SettingsReg.OpenKey(KeyName, true); // if registry key doesn't exist, create it

   param.srateIn     = srateIn;
   param.sampleRate  = sampleRate;
   param.wintype     = wintype;
   param.GainPos1    = SP1Gain->Position;
   param.BasePos1    = SP1Base->Position;
   param.GainPos2    = SP2Gain->Position;
   param.BasePos2    = SP2Base->Position;
   param.activePalette = activePalette;
   param.WF1GainPos    = WF1Gain->Position;
   param.WF1SpeedPos   = WF1Speed->Position;
   param.WF2GainPos    = WF2Gain->Position;
   param.WF2SpeedPos   = WF2Speed->Position;
   param.AGCGainPos    = AGCGain->Position;
   param.agc           = agc;
   param.driver        = driver;
   param.WF1ResPos     = WF1ResPos;
   param.CWWF2Resol    = CWWF2Resol;
   param.SSBWF2Resol   = SSBWF2Resol;
   param.FMWF2Resol    = FMWF2Resol;
   param.DRMWF2Resol   = DRMWF2Resol;
   param.datamode      = datamode;
   param.mode          = mode;
   param.SSBFF2locut   = SSBFF2locut;
   param.SSBFF2hicut   = SSBFF2hicut;
   param.FMFF2locut    = FMFF2locut;
   param.FMFF2hicut    = FMFF2hicut;
   param.DRMFF2locut   = DRMFF2locut;
   param.DRMFF2hicut   = DRMFF2hicut;
   param.FF1freq       = FF1freq;
   param.CWPitch       = CWPitch;
   param.CWbw          = CWbw;
   param.AvgIdx1       = AvgWF1->ItemIndex;
   param.AvgIdx2       = AvgWF2->ItemIndex;
   param.skew          = skew;
   param.Qmult         = Qmult;
   param.swapIQ        = swapIQ;
   param.Den2LvlPos    = Den2qfac;
   param.BlkThr        = BlkThr;
   param.vol           = vol;
   param.wf1slow       = wf1slow;
   param.Den1fac       = Den1fac;
   param.WF1ContrastPos = WF1Contrast->Position;
   param.WF2ContrastPos = WF2Contrast->Position;
   param.sp1fullspeed  = sp1fullspeed;
   param.polyfactor    = polyfactor;
   param.revWF1scroll  = revWF1scroll;
   strcpy(param.wavdir, wavdir.c_str());
   strcpy(param.wavname, wavname.c_str());
   param.WF1avg        = WF1avg;
   param.WF2avg        = WF2avg;
   param.extLOfreq     = extLOfreq;
   param.extLOoffset   = extLOoffset;
   param.wfm_deemph_tau= wfm_deemph_tau;
   param.wfm_rf_cut	   = wfm_rf_cut;
   param.wfm_audio_cut = wfm_audio_cut;
   param.leftdly       = leftdly;
   param.rightdly      = rightdly;
   param.procprio      = processPriority;
   param.vollocked     = vollocked;

   strcat(cfgname, name);

   SettingsReg.WriteBinaryData(cfgname, &param, sizeof(param));
   SettingsReg.WriteString("Version", VERSION);
   SettingsReg.CloseKey();

   delete &SettingsReg;

}

