//---------------------------------------------------------------------------

#ifndef Wave_ioH
#define Wave_ioH
//---------------------------------------------------------------------------

class WavIO
{
  public:

    bool OutOpen(char *);
	bool OutWriteBuf(void *, int);
	void OutClose(char * next);
	bool OutWrite(unsigned int * left, unsigned int * right, int writelen);
	bool InOpen(char *);
    void InRead(void *, void *, int&);
    void InClose(void);
	void InRewind(void);
	void InPosition(float);
    void OutRewind(void);
    void SetSampling(void);

    char inname[256], outname[256];
	int  inhandle, outhandle;
	int  Swy, SwM, Swd, Swh, Swm, Sws, wy, wM, wd, wh, wm, ws;

  private:

	short wavhdi[22];
	int   bitsamp, nomsamprate, format, blockalign, chan;
	__int64 prevsec;
	unsigned short buf16[BUFSIZE * 2];

#pragma pack(push)
#pragma pack(1)
	struct tb
	{
		unsigned short twobytes;
		unsigned char thirdbyte;
	} *threebytes;

	tb    buf24[BUFSIZE * 3];   // 2 should be enough, but sometimes it crashed...
#pragma pack(pop)

	tm *tblock;

	riffhdr iriffhdr;
	fmthdr  ifmthdr;
	datahdr idatahdr;
	rcvrhdr ircvrhdr;
	auxihdr iauxihdr;

	riffhdr oriffhdr;
	fmthdr  ofmthdr;
	datahdr odatahdr;
	auxihdr oauxihdr;
};

#include "main.h"

extern float rate;
#endif
